import { Component as IntactComponent, Props, VNodeComponentClass } from 'intact';
import { Component as ReactComponent, RefObject, ReactNode, Provider } from 'react';
import { normalizeChildren } from './normalize';
import { functionalWrapper } from './functionalWrapper';
import { FakePromises } from './fakePromise';
export * from 'intact';
export declare class Component<P = {}> extends IntactComponent<P> implements ReactComponent {
    static $cid: string;
    static normalize: typeof normalizeChildren;
    static functionalWrapper: typeof functionalWrapper;
    static contextType: import("react").Context<Component<{}> | null>;
    context: any;
    state: any;
    props: Readonly<P> & Readonly<{
        children?: ReactNode | undefined;
    }>;
    isReactComponent: boolean;
    $promises: FakePromises;
    $reactProviders: Map<Provider<any>, any>;
    private $parentPromises;
    private $elementRef;
    private $isReact;
    private $parentElement;
    constructor(props: Readonly<P> & Readonly<{
        children?: ReactNode | undefined;
    }>, context: any);
    constructor(props: Props<P, Component<P>> | null, $vNode: VNodeComponentClass, $SVG: boolean, $mountedQueue: Function[], $parent: Component | null);
    render(): import("react").ReactElement<{
        ref: RefObject<HTMLElement>;
        'data-intact-react': string;
    }, string | import("react").JSXElementConstructor<any>>;
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    private $done;
    setState(): void;
}
